
import java.awt.event.*;
import java.applet.Applet;
import java.awt.Graphics;
import java.awt.*;
import java.util.*;

//class to define virtual pest behaviors and methods
public class VirtualPest extends java.applet.Applet implements Runnable, MouseListener {

  //define thread to run the show
  Thread runner;
 
  //define pet states
  static final int HAPPY = 0;
  static final int PROVOKED = 1;
  static final int LONELY = 2;
  static final int ANGRY = 3;
  
  //define current state and counter
  int currentstate;
  int counter;
  
  //define user interface components
  Image petImage;
  Label labelAction;
  Label labelSound;
  Label labelState;
  TextField textAction;
  TextField textSound;
  TextField textState;
  TextField textCounter;
  TextField textRandom;
  Button btnPatDog;
  Panel ImagePanel;
  Panel UIPanel;
  Panel ContentPanel;
  
  
 public void init() {
   //let's start with a white background
   setBackground(Color.white);
   
   //create labels and textfields
   labelState = new Label ("Current State: ");
   labelAction = new Label("Action: ");
   labelSound = new Label("Sound: " );
   textAction = new TextField(30);  //displays the pet action
   textSound = new TextField(30);  //displays the pet sound
   textState = new TextField(30);  //displays the current state
   textCounter = new TextField(30);  //displays the counter
   textRandom = new TextField(30);  //displays the random generated number
   
   //hide counter, and randomly generated number
   //change false to true to see them again
   textCounter.setVisible(false);
   textRandom.setVisible(false);

  //create button to interact with "Pet"
   btnPatDog = new Button("Pat Dog"); //button to pat dog
   btnPatDog.addMouseListener(this);  //add a listener to handle button clicks
   
  //add components to panels, which are then added to the applet panel
   UIPanel = new Panel();   //add a panel for user interface components
   UIPanel.setLayout(new GridLayout(4, 2)); //set the components in a grid with 4 rows, 2 cols
   UIPanel.add(labelSound); 
   UIPanel.add(textSound);
   UIPanel.add(labelAction);
   UIPanel.add(textAction);
   UIPanel.add(labelState);
   UIPanel.add(textState); 
   UIPanel.add(btnPatDog);
   
   UIPanel.add(textCounter);  //used for debugging
   //UIPanel.add(textRandom);   //used for debugging
   ImagePanel = new Panel();  //add a panel to display the image
   petImage = ImagePanel.createImage(127, 238); //create a space for the image
   ContentPanel = new Panel();   //create a panel for content
   ContentPanel.setLayout(new GridLayout(2, 1)); //set the content grid
   ContentPanel.add(ImagePanel);  //add the image panel
   ContentPanel.add(UIPanel); //add the user interface panel
   add(ContentPanel);  //add the content to the applet panel
   
   
   currentstate = HAPPY;  //start the pet in a happy state
   counter = 0;  //init counter
   
   //get the image, in this case, it's in the same directory as our applet
   Toolkit kit = Toolkit.getDefaultToolkit();
   try{
   petImage = kit.getImage(new java.net.URL(getCodeBase() + "rocco3.jpg"));
   }
   catch(java.net.MalformedURLException e){} //have to catch this exception

}



 //checks current state and changes accordingly
  public int Pat(){
      //System.out.println("in Pat method");  //debug line
      if( currentstate == ANGRY )
          currentstate = PROVOKED;
      else if( currentstate == LONELY )
          currentstate = HAPPY;
      repaint();
      return currentstate;
   }

  public int Simulate() {
    // This function is the heart of a simulation
    // of state transitions reflected in a finite-state
    // machine.
    
     counter++;  // updates the Simulate counter.
      
    // The pest's state is retrieved from the "currentstate"
     // A random number in the interval (0,1) is generated.
      double n = Math.random();
     textRandom.setText(new Double(n).toString());
    // The state changes according to the following rules:

    // If the current state is "provoked", the pest has a 20%
    // chance of becoming "lonely" and an 80% chance of remaining
    // "provoked".
    // If the current state is "happy", the pest has a 10%
    // chance of becoming "angry" and a 90% chance of remaining
    // "happy".

      if( currentstate == PROVOKED && n < 0.2 )
          currentstate = LONELY;
      else if( currentstate == HAPPY && n < 0.1 )
          currentstate = ANGRY;

    // The display is updated to reflect the pest's state
      repaint();
      return currentstate;
    }

   //alter the pet's actions based on currentstate
    public void Display(){

	if( currentstate == HAPPY ){
          textAction.setText("Wag Tail");
          textAction.setForeground(Color.green);
          textSound.setText("");
	  textState.setForeground(Color.green);
          textState.setText("Rocco is happy! :)");
      }
      else if( currentstate == PROVOKED ){
          textAction.setText("BITE!!!");
          textAction.setForeground(Color.magenta);
          textSound.setText("");
          textState.setForeground(Color.magenta);
	  textState.setText("Ouch, Rocco is provoked!");
      }
      else if( currentstate == ANGRY ){
          textSound.setText("Grrr...");
          textSound.setForeground(Color.red);
          textAction.setText("");   
          textState.setForeground(Color.red);
	  textState.setText("Look out, Rocco is angry!");
      }
      else if( currentstate == LONELY ){
          textSound.setText("Woof woof");
          textSound.setForeground(Color.blue);
          textAction.setText("");   
          textState.setForeground(Color.blue);
	  textState.setText("Rocco is lonely :(");
      }
      else
          textAction.setText("Error - unknown state");
      
     }



    //we override update to eliminate the flicker
    public void update(Graphics g){
      paint(g);    
    }
    
    //alter the display
    public void paint(Graphics g){
      
      g.drawImage(petImage, 0, 0, this);
      Display();
      textCounter.setText(new Integer(counter).toString());
     }

    //lets get things started 
    public void run(){

    while (true) {
      //call simulate every 2 seconds
      Simulate();
      try{
         Thread.sleep(2000);
      }
      catch(InterruptedException e) {}
    
    }

    }

   //start the thread
   public void start() {
       
	if (runner == null) {
	    runner = new Thread(this);
	    runner.start();
 	}
    }

   //stop the thread
   public void stop() {
	runner = null;
   }

  
  //handle the user clicking the pat dog button
  public void mousePressed(MouseEvent e) {
    Pat();
    textCounter.setText("Pressed mouse button");
  }
  
  public void mouseClicked(MouseEvent e) {
    }

  
  public void mouseReleased(MouseEvent e) {
  }

  public void mouseEntered(MouseEvent e) {
  }
  
  public  void mouseExited(MouseEvent e) {
  }
  
}

















